/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGAnimatedNumberList.h"

#include <wtf/GetPtr.h>

#include "JSSVGNumberList.h"
#include "SVGNumberList.h"

using namespace KJS;

namespace WebCore {

/* Hash table */

static const HashEntry JSSVGAnimatedNumberListTableEntries[] =
{
    { "baseVal", JSSVGAnimatedNumberList::BaseValAttrNum, DontDelete|ReadOnly, 0, 0 },
    { "animVal", JSSVGAnimatedNumberList::AnimValAttrNum, DontDelete|ReadOnly, 0, 0 }
};

static const HashTable JSSVGAnimatedNumberListTable = 
{
    2, 2, JSSVGAnimatedNumberListTableEntries, 2
};

/* Hash table for prototype */

static const HashEntry JSSVGAnimatedNumberListPrototypeTableEntries[] =
{
    { 0, 0, 0, 0, 0 }
};

static const HashTable JSSVGAnimatedNumberListPrototypeTable = 
{
    2, 1, JSSVGAnimatedNumberListPrototypeTableEntries, 1
};

const ClassInfo JSSVGAnimatedNumberListPrototype::info = { "SVGAnimatedNumberListPrototype", 0, &JSSVGAnimatedNumberListPrototypeTable, 0 };

JSObject* JSSVGAnimatedNumberListPrototype::self(ExecState* exec)
{
    return KJS::cacheGlobalObject<JSSVGAnimatedNumberListPrototype>(exec, "[[JSSVGAnimatedNumberList.prototype]]");
}

const ClassInfo JSSVGAnimatedNumberList::info = { "SVGAnimatedNumberList", 0, &JSSVGAnimatedNumberListTable, 0 };

JSSVGAnimatedNumberList::JSSVGAnimatedNumberList(ExecState* exec, SVGAnimatedNumberList* impl)
    : m_impl(impl)
{
    setPrototype(JSSVGAnimatedNumberListPrototype::self(exec));
}

JSSVGAnimatedNumberList::~JSSVGAnimatedNumberList()
{
    SVGDocumentExtensions::forgetGenericContext<SVGAnimatedNumberList>(m_impl.get());
    ScriptInterpreter::forgetDOMObject(m_impl.get());
}

bool JSSVGAnimatedNumberList::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGAnimatedNumberList, KJS::DOMObject>(exec, &JSSVGAnimatedNumberListTable, this, propertyName, slot);
}

JSValue* JSSVGAnimatedNumberList::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case BaseValAttrNum: {
        SVGAnimatedNumberList* imp = static_cast<SVGAnimatedNumberList*>(impl());

        return toJS(exec, WTF::getPtr(imp->baseVal()));
    }
    case AnimValAttrNum: {
        SVGAnimatedNumberList* imp = static_cast<SVGAnimatedNumberList*>(impl());

        return toJS(exec, WTF::getPtr(imp->animVal()));
    }
    }
    return 0;
}

KJS::JSValue* toJS(KJS::ExecState* exec, SVGAnimatedNumberList* obj)
{
    return KJS::cacheDOMObject<SVGAnimatedNumberList, JSSVGAnimatedNumberList>(exec, obj);
}
SVGAnimatedNumberList* toSVGAnimatedNumberList(KJS::JSValue* val)
{
    return val->isObject(&JSSVGAnimatedNumberList::info) ? static_cast<JSSVGAnimatedNumberList*>(val)->impl() : 0;
}

}

#endif // ENABLE(SVG)
